#!/bin/bash

#PARAMETRES
REPERTOIRE="." 
VILLE_DEFAUT="lille"
INTERNET="firefox"

#Variables
TYPE="fr"
VOIX="/usr/share/mbrola/fr1/fr1"
SENTENCE=160
PITCH=40



# récupère la commande
ECOUTE ()
{
	
rec -r 16000 -d fichier.flac  &  aplay $REPERTOIRE/beep.wav  & if ret=`zenity --entry --title="Assitant vocal" --text="Enregistrement..." ;`
		then
			TEXTE=$ret
			if [ "$TEXTE" = "" ]
				then
				killall rec;
					
			fi
		else
			killall rec;
			EXIT;
			exit 2
	fi

killall rec;

if [ "$TEXTE" = "" ]
		then

TEXTE=$(wget -q -U "Mozilla/5.0" --post-file fichier.flac --header="Content-Type: audio/x-flac; rate=16000" -O - "http://www.google.com/speech-api/v1/recognize?lang=fr&client=chromium" | sed 's/^.*\[{.*:"\(.*\)",".*$/\1/') ;

fi

notify-send "Vous avez dit : " "$TEXTE" -i $REPERTOIRE/micro.png;
rm fichier.flac 
sleep 2 ;
pkill notify-osd ;

#on met le texte en lowercase
TEXTE=${TEXTE,,}
 
}

# fonction qui fait parler le script
DIRE()
{
pkill notify-osd ; notify-send "$1" -i $REPERTOIRE/chrome.png -t 2000 & espeak -v $TYPE -s $SENTENCE -p $PITCH "$1" | /usr/bin/mbrola $VOIX - -.au | aplay ; pkill notify-osd ; 
}


EXIT() 
{
DIRE "A bientôt"
sleep 2 ;
pkill notify-osd ;
exit 2;
}



#fonction de météo

METEO()
{

	VILLE_TEMPO=$(echo $TEXTE | sed -e "s/météo //g" | sed -e "s/meteo //g" |sed -e "s/à //g" |sed -e "s/a //g" | sed -e 's/ /-/g')

	if [ "$VILLE_TEMPO" != "météo" ];then
	{
	VILLE="$VILLE_TEMPO"
	}
	else
	{
	VILLE="$VILLE_DEFAUT"
	}
	fi	

notify-send "Météo à $VILLE" -i $REPERTOIRE/micro.png & DIRE "Voici la météo à $VILLE" & $INTERNET http://$VILLE.lachainemeteo.com/ & sleep 2  ;
 
}



#on lance le script

INIT () 
{
ECOUTE ;

#on extrait le premier mot de la commande
FIRST=`echo $TEXTE | awk '{print $1}'`

#on extrait tous les mots sauf le premier (dans le cas de commande type "ecris lorep ipsum" ou "carte anger"
CONTENU=$(echo $TEXTE | sed -e "s/$FIRST //g")

#commandes
case $TEXTE in

	"aurevoir"| "rien" | "stop" | "annuler" | "annulé") EXIT ;;

	"augmente le son" ) xdotool key "F8" ;; 

	"baisse le son" ) xdotool key "F7" ;; 

	"copie" ) xdotool key "Ctrl+c" ;;

	"colle" ) xdotool key "Ctrl+v" ;;

	"coupe" ) xdotool key "Ctrl+x" ;;

	"séléctionne tout"| "selectionne tout"| "selectionne tous" ) xdotool key "Ctrl+a" ;; 
		
	"météo"*| "météo à"*| "meteo"*| "meteo a"*|  "meteo à"*| "météo a"*   ) METEO ;; 

	"quelle heure est il" | "il est quelle heure" | "dis moi l'heure" | "l'heure" | "donne moi l'heure" ) 
		HEURE=$(date '+%H')
		MINUTE=$(date '+%M')
		SECONDE=$(date '+%S')
		DIRE "Il est $HEURE heure $MINUTE";;


#commandes pour lancer des sites web 

	"Facebook" | "facebook" ) DIRE "Je lance Facebook" & $INTERNET http://facebook.com/ & ;;
	
	"google news"  | "google actualité" | "google actualités" | "google actualite" ) DIRE "Je lance Google News" & $INTERNET http://news.google.com/ & ;;


#commandes pour ouvrir des dossiers

	"musique" ) DIRE "J'ouvre le dossier $TEXTE" & xdg-open ~/Musique & ;;

	"image" )  DIRE "J'ouvre le dossier $TEXTE" & xdg-open ~/Images & ;;

	"document" ) DIRE "J'ouvre le dossier $TEXTE" &  xdg-open ~/ &;;

	"vidéo" )  DIRE "J'ouvre le dossier $TEXTE" & xdg-open ~/vidéos & ;;

	"bureau" )  DIRE "J'ouvre le dossier $TEXTE" & xdg-open ~/Bureau &;;

	"dropbox" )  DIRE "J'ouvre le dossier $TEXTE" & xdg-open ~/Dropbox &;;

	"téléchargement" | "telechargement" ) DIRE "J'ouvre le dossier $TEXTE" &  xdg-open ~/Téléchargements &;;


#commande reconnaissable au premier mot
	
	"recherche"* ) 
		DIRE "Je lance la recherche $CONTENU" & $INTERNET http://www.google.com/search?q="$CONTENU" ;;

	"wikipedia"* | "wikipédia"* )
		DIRE "Je lance la recherche $CONTENU sur wikipédia" & $INTERNET http://fr.wikipedia.org/wiki/"$CONTENU" & ;;

	"youtube"* ) 
		DIRE "Je lance la recherche $CONTENU sur youtube"

		$INTERNET http://www.youtube.com/results?search_query="$CONTENU"&oq="$CONTENU"&gs_l=youtube-reduced.3..0l4.505.530.0.1078.3.2.0.0.0.0.323.323.3-1.1.0...0.0.sozusCDAl78 & ;;


	"dictionnaire"* )
		DIRE "Je recherche la définition de $CONTENU sur Internet "
		$INTERNET http://www.le-dictionnaire.com/definition.php?mot="$CONTENU" &;;


	"carte"* | "carte de"*  | "je veux voir la carte de"* | "mets moi la carte"* )

		CONTENU_CARTE=$(echo $TEXTE | sed -e "s/$FIRST //g" | sed -e "s/de //g")

		DIRE "Je lance la carte de $CONTENU_CARTE"

		$INTERNET  "https://maps.google.fr/maps?hl=en&authuser=0&q=$CONTENU_CARTE" &;;

	"itinéraire"* | "itineraire"* )
		CONTENU=$(echo $CONTENU | sed -e "s/entre //g" | sed -e "s/et //g")
		DEPART=`echo $CONTENU | awk '{print $1}'`
		ARRIVEE=$(echo $CONTENU | sed -e "s/$DEPART //g")
	
		DIRE "Je lance l'intinéraire entre $DEPART et $ARRIVEE"
		$INTERNET  "https://maps.google.com/maps?saddr=$DEPART&daddr=$ARRIVEE" &;;

		

#fonction pour écrire

	 "écrire"*  | "ecrire"*  | "écris"* | "ecris"*  ) 
		xdotool type "$CONTENU" & ;;



#Conversation (init pour relancer la conversation)

	"bonjour"* ) DIRE "Bonjour" & INIT  &;;

	"comment vas tu" | "comment ça va" | "ça va" ) DIRE "je vais bien et toi ?" & INIT   &;;



#Aucune commande reconnu : on relance le script ou on recherche sur inernet
	""  | " " )DIRE "Je n'ai pas compris, pouvez-vous répéter ?";  INIT ;;

	* ) DIRE "Je n'ai pas compris, je cherche sur Google $CONTENU" & $INTERNET http://www.google.com/search?q="$CONTENU" ;;

	

esac;

}
INIT ;

exit 2;;





